# -*- coding: utf-8 -*-
"""
I've taken the code from the nov16/FSAStandAlone.py and the idleBrain.py
I modified crhBrain to get this. Just have one neuron that gets
turned on by the clock in the environment (in the transfer functions).
"""
# pragma: no cover

__author__ = 'Template'

from hbp_nrp_cle.brainsim import simulator as sim
import numpy as np
import logging

from nealNRPCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions

logger = logging.getLogger(__name__)

def createNeurons():
    #from state machine for nest
    cells=sim.Population(50,sim.IF_cond_exp,fsa.CELL_PARAMS)

    return cells

#This is just a copy of the state machines makeCa.  It's just changed
#The intra_ca_weight from 0.022 to 0.02
def makeCheekyCA(neurons,CANum):
    connector = []
    for fromOffset in range (0,fsa.CA_SIZE-fsa.CA_INHIBS):
        fromNeuron = fromOffset + (CANum*fsa.CA_SIZE)
        for toOffset in range (0,fsa.CA_SIZE-fsa.CA_INHIBS):
            toNeuron = toOffset + (CANum*fsa.CA_SIZE)
            if (toNeuron != fromNeuron):
                    connector = connector + [(fromNeuron,toNeuron,0.02,
                                              fsa.neal.DELAY)]
        neal.nealProjection(neurons,neurons,connector,'excitatory')

    #excitatory turn on inhibitory
    connector = []
    for fromOffset in range (0,fsa.CA_SIZE-fsa.CA_INHIBS):
        fromNeuron = fromOffset + (CANum*fsa.CA_SIZE)
        for toOffset in range (fsa.CA_SIZE-fsa.CA_INHIBS,fsa.CA_SIZE):
            toNeuron = toOffset + (CANum*fsa.CA_SIZE)
            connector = connector + [(fromNeuron,toNeuron,
                            fsa.INTRA_CA_TO_INHIB_WEIGHT, fsa.neal.DELAY)]
    neal.nealProjection(neurons,neurons,connector,'excitatory')

    #inhibitory slows excitatory 
    connector = []
    for fromOffset in range (fsa.CA_SIZE-fsa.CA_INHIBS,fsa.CA_SIZE):
        fromNeuron = fromOffset + (CANum*fsa.CA_SIZE)
        for toOffset in range (0,fsa.CA_SIZE-fsa.CA_INHIBS):
            toNeuron = toOffset + (CANum*fsa.CA_SIZE)
            connector = connector + [(fromNeuron,toNeuron,
                        fsa.INTRA_CA_FROM_INHIB_WEIGHT, fsa.neal.DELAY)]
    neal.nealProjection(neurons,neurons,connector,'inhibitory')
        


#-----Main
simName = "nest"
neal = NealCoverFunctions(simName,sim)
fsa = FSAHelperFunctions(simName,sim)

#Does the NRP require it to be called circuit or is a transfer function thing?
circuit = createNeurons()

#0 is not a state, but the move state forward signal

fsa.oneNeuronTurnsOnState(circuit,0,circuit,1)

#I'd like to use this, but it's turned on from the nrp using a fixed_frequency
#spike source, and this causes it to over fire, which shuts it down.
#fsa.makeCA(circuit,1)
makeCheekyCA(circuit,1)

fsa.stateTurnsOffState(circuit,1,circuit,4)
fsa.oneNeuronStimulatesState(circuit,2,circuit,2,0.05)
fsa.stateHalfTurnsOnState(circuit,1,circuit,2)

#fsa.makeCA(circuit,2)
makeCheekyCA(circuit,2)
fsa.stateTurnsOffState(circuit,2,circuit,1)
fsa.oneNeuronStimulatesState(circuit,5,circuit,3,0.05)
fsa.stateHalfTurnsOnState(circuit,2,circuit,3)

#fsa.makeCA(circuit,3)
makeCheekyCA(circuit,3)
fsa.stateTurnsOffState(circuit,3,circuit,2)
fsa.oneNeuronStimulatesState(circuit,2,circuit,4,0.05)
fsa.stateHalfTurnsOnState(circuit,3,circuit,4)

#fsa.makeCA(circuit,4)
makeCheekyCA(circuit,4)
fsa.stateTurnsOffState(circuit,4,circuit,3)
fsa.oneNeuronStimulatesState(circuit,5,circuit,1,0.05)
fsa.stateHalfTurnsOnState(circuit,4,circuit,1)
