# -*- coding: utf-8 -*-
"""
I've taken the code from the nov16/FSAStandAlone.py and the idleBrain.py
I modified crhBrain to get this. Just have one neuron that gets
turned on by the clock in the environment (in the transfer functions).
"""
# pragma: no cover

__author__ = 'Template'

from hbp_nrp_cle.brainsim import simulator as sim
import numpy as np
import logging

from nealNRPCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions

logger = logging.getLogger(__name__)

def createNeurons():
    #from state machine for nest
    cells=sim.Population(50,sim.IF_cond_exp,fsa.CELL_PARAMS)

    return cells


#-----Main
simName = "spinnaker"
neal = NealCoverFunctions(simName,sim)
fsa = FSAHelperFunctions(simName,sim)

startInputNeuron = sim.Population(1, sim.IF_cond_exp,fsa.CELL_PARAMS)
nextStateNeuron = sim.Population(1, sim.IF_cond_exp,fsa.CELL_PARAMS)

#To get the spinnaker nrp reading from the brain, I use single neurons.
forwardNeuron = sim.Population(1, sim.IF_cond_exp,fsa.CELL_PARAMS)
leftNeuron = sim.Population(1, sim.IF_cond_exp,fsa.CELL_PARAMS)

#Does the NRP require it to be called circuit or is a transfer function thing?
circuit = createNeurons()

#brain to nrp
fsa.stateTurnsOnOneNeuron(circuit,1,leftNeuron,0)
fsa.stateTurnsOnOneNeuron(circuit,3,forwardNeuron,0)

fsa.oneNeuronTurnsOnState(startInputNeuron,0,circuit,1)
fsa.oneNeuronTurnsOnState(nextStateNeuron,0,circuit,0)
#0 is not a state.  It is used to signal the next state.

fsa.makeCA(circuit,1)
fsa.stateTurnsOffState(circuit,1,circuit,4)
fsa.stateHalfTurnsOnState(circuit,1,circuit,2)
#This is for half on in one firing.
halfWt = 0.006 
fsa.stateStimulatesState(circuit,0,circuit,2,halfWt)

fsa.makeCA(circuit,2)
fsa.stateTurnsOffState(circuit,2,circuit,1)
fsa.stateStimulatesState(circuit,0,circuit,3,halfWt)
fsa.stateHalfTurnsOnState(circuit,2,circuit,3)

fsa.makeCA(circuit,3)
fsa.stateTurnsOffState(circuit,3,circuit,2)
fsa.stateStimulatesState(circuit,0,circuit,4,halfWt)
fsa.stateHalfTurnsOnState(circuit,3,circuit,4)

fsa.makeCA(circuit,4)
fsa.stateTurnsOffState(circuit,4,circuit,3)
fsa.stateStimulatesState(circuit,0,circuit,1,halfWt)
fsa.stateHalfTurnsOnState(circuit,4,circuit,1)

